#include "StdAfx.h"
#include "LogFile.h"

CLogFile::CLogFile(void)
	{

	}
CLogFile::CLogFile(char* pclogFile)
	{
	if(!m_stdLogFile.Open(CString(pclogFile),CFile::modeCreate|CFile::modeWrite|CFile::modeNoTruncate)){
		TRACE0("unable to open log file");
		return ;
		}
	}
CLogFile::~CLogFile(void)
	{
	CloseLogFile();
	}

void CLogFile::OpenLogFile(char* pchrFileName)
	{
	if(!m_stdLogFile.Open(CString(pchrFileName),CFile::modeCreate|CFile::modeWrite|CFile::modeNoTruncate)){
		TRACE0("unable to open log file");
		return ;
		}
	
	}

void CLogFile::AddLog(char* pchrLog,bool CrLf/*=true*/)
	{
	if(m_stdLogFile.m_hFile!=INVALID_HANDLE_VALUE){
		m_stdLogFile.SeekToEnd();
		m_stdLogFile.WriteString(CString(pchrLog));
		if(CrLf)
		m_stdLogFile.WriteString(CString("\r\n"));
		}

	}
void CLogFile::CloseLogFile(void)
	{
	if(m_stdLogFile.m_hFile!=INVALID_HANDLE_VALUE)
		m_stdLogFile.Close();
	}
