// ReaderDll_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReaderDll_demo.h"
#include "LogPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About




CLogPage::CLogPage()
: CPropertyPage(CLogPage::IDD)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CLogPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLogPage, CPropertyPage)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_SAVE, &CLogPage::OnBnClickedSave)
ON_BN_CLICKED(IDC_CLEAR, &CLogPage::OnBnClickedClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CLogPage message handlers

BOOL CLogPage::OnInitDialog()
{
CPropertyPage::OnInitDialog();
	CString szTemp;
	szTemp.LoadString(IDS_SAVE);
	SetDlgItemText(IDC_SAVE,szTemp);
	szTemp.LoadString(IDS_SHOW_LINE);
	SetDlgItemText(IDC_SHOW_LINE,szTemp);
	szTemp.LoadString(IDS_CLEAR);
	SetDlgItemText(IDC_CLEAR,szTemp);
	
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLogPage::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLogPage::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//Used to add log in Main LogBox.


void CLogPage::AddLog(CString strLog,bool crgRtrn/*=true*/)
	{
		CString strMes;	
		CEdit* edt=(CEdit*)GetDlgItem(IDC_EDIT_LOG);
		if(((CButton*)GetDlgItem(IDC_SHOW_LINE))->GetCheck()==BST_CHECKED){
			strMes.Format(L"%d: %s",edt->GetLineCount(),strLog);
		}else
		strMes=strLog;
		m_strLog.Append(strMes);
		if(crgRtrn)
			m_strLog.Append(L"\r\n");
		SetDlgItemText(IDC_EDIT_LOG,m_strLog);
		edt->LineScroll(edt->GetLineCount());

	}

void CLogPage::addLog(CString strLog , CString strTime)
	{
		strLog.Append(L"(");
		strLog.Append(strTime);
		strLog.Append(L")");
		AddLog(strLog);
	}
void CLogPage::OnBnClickedSave(){
	CFileDialog fd(false,L".txt",L"ReaderDllLog.txt",4|2,L"Text files(*.txt)|*.txt|All files(*.*)|*.*|",this);
	if(fd.DoModal()==IDOK){
		CStdioFile stdFile(fd.GetPathName(),CFile::modeCreate|CFile::modeNoTruncate|CFile::modeWrite);
		if(stdFile){
			stdFile.SeekToEnd();
			stdFile.WriteString(m_strLog);
			stdFile.Flush();
			stdFile.Close();
			}
		}

	}
void CLogPage::OnBnClickedClear(){
	m_strLog=L"";
	AddLog(L"",false);
	}