// SpeedTestPage.cpp : implementation file
//

#include "stdafx.h"
#include "ReaderDll_demo.h"
#include "SpeedTestPage.h"
//#include "LogFile.h"
#include "HaxaOperation.h"
#define RECV_EVENT 1000
#define MAX_BUFFER 1024
// CSpeedTestPage dialog
DWORD WINAPI ThreadProc(LPVOID lpVoid);
IMPLEMENT_DYNAMIC(CSpeedTestPage, CPropertyPage)
HANDLE handle=INVALID_HANDLE_VALUE;
CSpeedTestPage::CSpeedTestPage()
: CPropertyPage(CSpeedTestPage::IDD)
{

}

CSpeedTestPage::~CSpeedTestPage()
{
}

void CSpeedTestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LBL, m_MsgBoard);
	DDX_Control(pDX, IDC_PROGRESS1, m_pb);
}


BEGIN_MESSAGE_MAP(CSpeedTestPage, CPropertyPage)
	ON_BN_CLICKED(IDOK, &CSpeedTestPage::OnBnClickedOk)
	ON_BN_CLICKED(IDC_TEST1, &CSpeedTestPage::OnBnClickedTest1)
	//ON_BN_CLICKED(IDC_TEST2, &CSpeedTestPage::OnBnClickedTest2)
	ON_BN_CLICKED(IDC_CNTREAD, &CSpeedTestPage::OnBnClickedCntread)
	ON_WM_TIMER()
	//ON_BN_CLICKED(IDC_RDRID, &CSpeedTestPage::OnBnClickedRdrid)
	ON_BN_CLICKED(IDC_CNTREAD2, &CSpeedTestPage::OnBnClickedCntread2)
	ON_BN_CLICKED(IDC_BUTTON1, &CSpeedTestPage::OnBnClickedButton1)
END_MESSAGE_MAP()


// CSpeedTestPage message handlers

void CSpeedTestPage::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
}

BOOL CSpeedTestPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
}


void CSpeedTestPage::OnBnClickedTest1()
{
	int index=0;
	CClock clock;
	CString szTemp;
	//Here goes Bench Mark test1.
	if(!theApp.m_hCom && !theApp.m_hReader){
		theApp.m_Logpage->AddLog(L"Reader is not connected");
		return ;
	}
	char pcMasterKey[32]={0};
	//memset(pcMasterKey,'0',32);
	char buffer[1026]={0x84,0x00,0x00,0x10};
	char output[1026]={0};
	//1. Select Appplication 0x000010
	unsigned int length[10];
	//card selction at speed=424
	theApp.m_Logpage->AddLog(L"Test Started....");
	clock.Start();
	ZeroMemory(buffer,1026);
	buffer[index++]='0';
	buffer[index++]='4';
	RDR_SendCommandGetData(theApp.m_hReader, "h", buffer, output);
	clock.End();
	szTemp=L"Select Command   ";
	szTemp.Append(clock.GetSecMs());
	theApp.m_Logpage->AddLog(szTemp);
	ZeroMemory(buffer,1026);
	//buffer[index++]=3;
	index=0;
	buffer[index++]='0';
	buffer[index++]='0';
	buffer[index++]='0';
	buffer[index++]='0';
	buffer[index++]='0';
	buffer[index++]='0';

	//
	CClock clockMain;
	clockMain.Start();
	//#ifdef APPLICATION1
	//selction application 0x000010
	{

		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SELECT_APPLICATION, buffer, output);
		clock.End();	szTemp=L"Select Application   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in application selection");
			return ;
		}
		//2.	Read Data.. fileno=0x0f and Application=0x000010,accessrigts=0xE002
		//Filesettings before Reading data..
		{

			index=1;
			int fileno=0x0f;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	
			szTemp=L"Get Desfire File settings   ";
			szTemp.Append(clock.GetSecMs());
			theApp.m_Logpage->AddLog(szTemp);clock.End();
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;/*output[3/*com settings]*/;
			buffer[index++]=0x02;//output[4/*access rights settings*/];
			buffer[index++]=0xE0;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); 
			RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();
			szTemp=L"Set Desfire File settings   ";
			szTemp.Append(clock.GetSecMs());
			theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=0x10;

			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start();
			RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	
			szTemp=L"Read Data   ";	
			szTemp.Append(clock.GetSecMs());	
			theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		//Reading second file 0x00
		//Filesettings before Reading data..
		{
			index=1;
			int fileno=0x00;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSetting   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x32;//output[4/*access rights settings*/];
			buffer[index++]=0xE3;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=0x10;

			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}
		}
	}
	//#else
	//Another application selection..0x000011
	{
		index=1;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=0x00;
		buffer[index++]=0x00;
		buffer[index++]=0x11;
		buffer[0]=index-1;
		clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SELECT_APPLICATION, buffer, output);
		clock.End();	szTemp=L"Select Application   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in application selection");
			return ;
		}
		//2.	Read Data.. fileno=0x0f and Application=0x000010,accessrigts=0xE002
		//Filesettings before Reading data..
		{
			index=1;
			int fileno=0x0f;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x01;//output[4/*access rights settings*/];
			buffer[index++]=0xE0;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=0x10;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//Authentication..
			//for same mode=0, we need to provide keyNo and Key.
			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			buffer[index++]=0x02;
			BYTE KeyData[16]={0};
			memcpy(&buffer[index],KeyData,16);
			index+=16;
			buffer[0]=index-1;
			clock.Start(); 
			RDR_DESFire(theApp.m_hReader,DESFIRE_AUTHENICATE, buffer, output);	
			clock.End();
			szTemp=L"Authentication   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}
		}
		{
			//7. Read Data.. file no=0x00, offset=0x00,Length=56
			index=1;
			int fileno=0x00;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0xE2;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=56;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//8. Read Data.. file no=0x01, offset=0x00,Length=32
			index=1;
			int fileno=0x01;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x33;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//9. Read Data.. file no=0x02, offset=0x00,Length=56
			index=1;
			int fileno=0x02;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x32;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//10. GetValue.. file no=0x03
			index=1;
			int fileno=0x03;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x12 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x33;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			//int nDataLength=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_GET_VALUE, buffer, output);	
			clock.End();	szTemp=L"Get Value   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=4+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in GetValue");
				return ;
			}

		}
		{
			//11. Read Data.. file no=0x0A, offset=0x00,Length=32
			index=1;
			int fileno=0x0A;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x32;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"setFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L"Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//12. Read Data.. file no=0x0B, offset=0x32,Length=32
			index=1;
			int fileno=0x0B;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x32;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"setFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			int nDataLength=32;
			int offset=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=offset;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			buffer[index++]=nDataLength;
			buffer[index++]=0;
			buffer[index++]=0;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
			clock.End();	szTemp=L" Read Data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=nDataLength+1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//13. Write Data .. file no=0x0A, offset=0x32,Length=32
			index=1;
			int fileno=0x0A;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x32;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"setFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			BYTE pTempData[32]={0};
			memset(pTempData,'X',32);
			int nDataLength=32;
			int offset=32;
			//buffer[index++]=0x0f;
			//offset
			buffer[index++]=offset;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			memcpy(&buffer[index],pTempData,nDataLength);
			index+=nDataLength;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_DATA, buffer, output);	
			clock.End();	szTemp=L"Write data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//14. Write Data .. file no=0x00, offset=0x0,Length=56
			index=1;
			int fileno=0x00;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0xE2;//output[5/*access rights settings*/];			buffer[0]=index-1;
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			BYTE pTempData[56]={0};
			memset(pTempData,'X',56);
			int nDataLength=56;
			int offset=0;
			//offset
			buffer[index++]=offset;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			memcpy(&buffer[index],pTempData,nDataLength);
			index+=nDataLength;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_DATA, buffer, output);	
			clock.End();	szTemp=L"Write data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//15. Write Data .. file no=0x01, offset=0x0,Length=32
			index=1;
			int fileno=0x01;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x33;//output[5/*access rights settings*/];			buffer[0]=index-1;
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			BYTE pTempData[32]={0};
			memset(pTempData,'X',32);
			int nDataLength=32;
			int offset=0;
			//offset
			buffer[index++]=offset;
			buffer[index++]=0;
			buffer[index++]=0;
			//Length...
			memcpy(&buffer[index],pTempData,nDataLength);
			index+=nDataLength;
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_DATA, buffer, output);	
			clock.End();	szTemp=L"Write data   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}
		{
			//16. Write Record.. file no=0x04, offset=0x0,Length=32
			index=1;
			int fileno=0x04;
			/*ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[index++]=fileno;
			buffer[0]=index-1;
			clock.Start();
			RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"GetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x0e || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
			}
			index=1;*/
			ZeroMemory(buffer,1026);
			buffer[index++]=fileno;
			buffer[index++]=0;//output[3/*com settings*/];
			buffer[index++]=0x21;//output[4/*access rights settings*/];
			buffer[index++]=0x33;//output[5/*access rights settings*/];
			buffer[0]=index-1;
			ZeroMemory(output,1026);
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
			clock.End();	szTemp=L"SetFileSettings   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}

			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			index=1;
			BYTE pTempData[32]={0};
			memset(pTempData,'X',32);
			int nDataLength=32;
			int offset=0;
			int records=1;
			//offset
			buffer[index++]=offset;
			buffer[index++]=0;
			buffer[index++]=0;
			//records
			buffer[index++]=32;
			buffer[index++]=0;
			buffer[index++]=0;

			memcpy(&buffer[index],pTempData,nDataLength);
			index+=nDataLength;
			buffer[0]=index-1;
			clock.Start();
			RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_RECORDS, buffer, output);	
			clock.End();	
			szTemp=L"Write Record   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=1 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" Failed in reading");
				return ;
			}

		}

		{
			//17. Commit Transections
			index=1;
			ZeroMemory(buffer,1026);
			ZeroMemory(output,1026);
			buffer[0]=index-1;
			clock.Start(); RDR_DESFire(theApp.m_hReader, DESFIRE_COMMIT_TRANSACTION, buffer, output);
			clock.End();	szTemp=L"Commit Transection   ";	szTemp.Append(clock.GetSecMs());	theApp.m_Logpage->AddLog(szTemp);
			if(output[0]!=0x01 || output[1]!=0x00){
				theApp.m_Logpage->AddLog(L" fail in get file settings");
				return ;
			}
		}



	}
	clockMain.End();
	szTemp.Format(L"Total Time Taken  %s",clockMain.GetSecMs());
	theApp.m_Logpage->AddLog(szTemp);
	theApp.m_Logpage->AddLog(L"Test End Successfully....");


	//#endif
	//4.	Select application..0x000011
	//5.	Read Data..
	//6.	Authenticate.
	//7.	ReadData
	//8.	ReadData
	//9.	ReadData
	//10.	GetValue
	//11.	ReadData
	//12.	ReadData
	//13.	WriteData
	//14.	WriteData
	//15.	WriteData
	//16.	WriteRecord.
	//17.	CommitTransection.

}

void CSpeedTestPage::OnBnClickedTest2()
{
	int index=0;
	CClock clock;
	CString szTemp;
	//Here goes Bench Mark test1.
	if(!theApp.m_hCom && !theApp.m_hReader){
		theApp.m_Logpage->AddLog(L"Reader is not connected");
		return ;
	}
	char pcMasterKey[32]={0};
	//memset(pcMasterKey,'0',32);
	char buffer[1026]={0x84,0x00,0x00,0x20};
	char output[1026]={0};
	//1. Select Appplication 0x000010
	unsigned int length[10];
	//card selction at speed=424
	theApp.m_Logpage->AddLog(L"Bench Mark Test2 Started....");
	clock.Start();
	RDR_SendCommandGetData2(theApp.m_hReader, "hightspeed select", buffer, 1,output,length);
	clock.End();
	szTemp=L"Select Command   ";
	szTemp.Append(clock.GetSecMs());
	theApp.m_Logpage->AddLog(szTemp);
	buffer[0]=0x03;
	CClock clockMain;
	clockMain.Start();
	//#ifdef APPLICATION1
	//selction application 0x000020
	{
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SELECT_APPLICATION, buffer, output);
		clock.End();	
		szTemp=L"Select Application   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in application selection");
			return ;
		}
	}
	//2.	Read Data.. fileno=0x0f and Application=0x000010,accessrigts=0xE002
	//Filesettings before Reading data..
	{
		index=1;
		int fileno=0x0f;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();	
		szTemp=L"Get Desfire File settings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);clock.End();
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0;//output[3/*com settings*/];
		buffer[index++]=0xF1;//output[4/*access rights settings*/];
		buffer[index++]=0xEF;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"Set Desfire File settings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=0x10;
		//offset
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=nDataLength+1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	//Another application selection..0x000021
	{
		index=1;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=0x00;
		buffer[index++]=0x00;
		buffer[index++]=0x21;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SELECT_APPLICATION, buffer, output);
		clock.End();
		szTemp=L"Select Application   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in application selection");
			return ;
		}
	}
	{
		//Authentication..
		//for same mode=0, we need to provide keyNo and Key.
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		buffer[index++]=0x07;//Key =0x07
		BYTE KeyData[16]={0};
		memcpy(&buffer[index],KeyData,16);
		index+=16;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_AUTHENICATE, buffer, output);	
		clock.End();
		szTemp=L"Authentication   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
	}
	//2.	Read Data.. fileno=0x0f and Application=0x000010,accessrigts=0xE002
	//Filesettings before Reading data..
	{
		index=1;
		int fileno=0x0E;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0;//output[3/*com settings*/];
		buffer[index++]=0x21;//output[4/*access rights settings*/];
		buffer[index++]=0x7f;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=0x20;
		//offset
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=nDataLength+1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//6. Read Data.. file no=0x0F, offset=0x00,Length=32
		index=1;
		int fileno=0x0F;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0;//output[3/*com settings*/];
		buffer[index++]=0x31;//output[4/*access rights settings*/];
		buffer[index++]=0x7F;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=0x20;
		//offset
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=nDataLength+1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//7. Read Data.. file no=0x00, offset=0x00,Length=128
		index=1;
		int fileno=0x00;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=01;//output[3/*com settings*/];
		buffer[index++]=0x41;//output[4/*access rights settings*/];
		buffer[index++]=0x76;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=128;
		//offset
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());	
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//8. Read Data.. file no=0x01, offset=0x00,Length=244
		index=1;
		int fileno=0x01;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());	
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0x01;//output[3/*com settings*/];
		buffer[index++]=0x41;//output[4/*access rights settings*/];
		buffer[index++]=0x7f;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";	
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=224;
		//offset
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int offset=nDataLength;
		nDataLength=244-224;
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data Next Block ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//9. Read Data.. file no=0x01, offset=244,Length=140
		//index=1;
		//int fileno=0x01;
		//ZeroMemory(buffer,1026);
		//ZeroMemory(output,1026);
		//buffer[index++]=fileno;
		//buffer[0]=index-1;
		//clock.Start(); 
		//RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		//clock.End();
		//szTemp=L"GetFileSettings   ";
		//szTemp.Append(clock.GetSecMs());	
		//theApp.m_Logpage->AddLog(szTemp);
		//if(output[0]!=0x08 || output[1]!=0x00){
		//	theApp.m_Logpage->AddLog(L" fail in get file settings");
		//	return ;
		//	}
		//index=1;
		//ZeroMemory(buffer,1026);
		//buffer[index++]=fileno;
		//buffer[index++]=output[3/*com settings*/];
		//buffer[index++]=output[4/*access rights settings*/];
		//buffer[index++]=output[5/*access rights settings*/];
		//buffer[0]=index-1;
		//ZeroMemory(output,1026);
		//clock.Start(); 
		//RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		//clock.End();
		//szTemp=L"SetFileSettings   ";
		//szTemp.Append(clock.GetSecMs());
		//theApp.m_Logpage->AddLog(szTemp);
		//if(output[0]!=0x01 || output[1]!=0x00){
		//	theApp.m_Logpage->AddLog(L" fail in get file settings");
		//	return ;
		//	}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=140;
		int offset=244;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//10. Read Data.. file no=0x02, offset=0,Length=244
		index=1;
		int fileno=0x02;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());	
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0x01;//output[3/*com settings*/];
		buffer[index++]=0x41;//output[4/*access rights settings*/];
		buffer[index++]=0x76;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=224;
		int offset=0;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
		index=1;
		offset=nDataLength;
		nDataLength=244-nDataLength;

		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data Next Blcok   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		cExpectedLen=(nDataLength+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
	}
	{
		//11. Read Data.. file no=0x02, offset=244,Length=44
		//index=1;
		//int fileno=0x02;
		//ZeroMemory(buffer,1026);
		//ZeroMemory(output,1026);
		//buffer[index++]=fileno;
		//buffer[0]=index-1;
		//clock.Start(); 
		//RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		//clock.End();
		//szTemp=L"GetFileSettings   ";
		//szTemp.Append(clock.GetSecMs());	
		//theApp.m_Logpage->AddLog(szTemp);
		//if(output[0]!=0x08 || output[1]!=0x00){
		//	theApp.m_Logpage->AddLog(L" fail in get file settings");
		//	return ;
		//	}
		//index=1;
		//ZeroMemory(buffer,1026);
		//buffer[index++]=fileno;
		//buffer[index++]=output[3/*com settings*/];
		//buffer[index++]=output[4/*access rights settings*/];
		//buffer[index++]=output[5/*access rights settings*/];
		//buffer[0]=index-1;
		//ZeroMemory(output,1026);
		//clock.Start();
		//RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		//clock.End();
		//szTemp=L"SetFileSettings   ";	
		//szTemp.Append(clock.GetSecMs());
		//theApp.m_Logpage->AddLog(szTemp);
		//if(output[0]!=0x01 || output[1]!=0x00){
		//	theApp.m_Logpage->AddLog(L" fail in get file settings");
		//	return ;
		//	}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		int nDataLength=44;
		int offset=244;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA, buffer, output);	
		clock.End();
		szTemp=L"Read Data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=nDataLength+1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//12. GetValue.. file no=0x03
		index=1;
		int fileno=0x03;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x12 || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}*/
		index=1;
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0x01;//output[3/*com settings*/];
		buffer[index++]=0x51;//output[4/*access rights settings*/];
		buffer[index++]=0x7f;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";	
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		//offset
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_GET_VALUE, buffer, output);	
		clock.End();
		szTemp=L"Get Value   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=4+1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in GetValue");
			return ;
		}

	}
	{
		//13. Read Record.. file no=0x04, offset=0x0,Length=244
		index=1;
		int fileno=0x04;
		/*ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x0e || output[1]!=0x00){
		theApp.m_Logpage->AddLog(L" fail in get file settings");
		return ;
		}
		index=1;*/
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=0x00;//output[3/*com settings*/];
		buffer[index++]=0xf1;//output[4/*access rights settings*/];
		buffer[index++]=0x76;//output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		//BYTE pTempData[32]={0};
		//memset(pTempData,'X',32);
		int nDataLength=6;
		int offset=0;
		int recordSize=36;
		//records
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length
		buffer[index++]=nDataLength & 0xFF;
		buffer[index++]=nDataLength>>8 & 0xFF;
		buffer[index++]=nDataLength>>16 & 0xFF;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_RECORDS, buffer, output);	
		clock.End();	
		szTemp=L"Read Record   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength*recordSize+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
		index=1;
		offset=nDataLength;
		nDataLength=1;
		recordSize=36;
		//records
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_RECORDS, buffer, output);	
		clock.End();	
		szTemp=L"Next Read Record   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		cExpectedLen=(nDataLength*recordSize+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
	}
	{
		//15. Read Record.. file no=0x05, offset=0,Length=64
		index=1;
		int fileno=0x05;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x0e || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}
		index=1;
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=output[3/*com settings*/];
		buffer[index++]=output[4/*access rights settings*/];
		buffer[index++]=output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		//BYTE pTempData[32]={0};
		//memset(pTempData,'X',32);
		int nDataLength=2;
		int offset=0;
		int recordSize=32;
		//records
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[index++]=0;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_READ_RECORDS, buffer, output);	
		clock.End();	
		szTemp=L"Read  2 Record 64 Bytes   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		char cExpectedLen=(nDataLength*recordSize+1)& 0xFF;
		if(output[0]!=cExpectedLen || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//Authentication.. Key no=0x06
		//for same mode=0, we need to provide keyNo and Key.
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		buffer[index++]=0x06;//Key =0x06
		BYTE KeyData[16]={0};
		memcpy(&buffer[index],KeyData,16);
		index+=16;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_AUTHENICATE, buffer, output);	
		clock.End();
		szTemp=L"Authentication With key 0x06 ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}
	}
	{
		//17. Write Record.. file no=0x04, offset=0x0,Length=36
		index=1;
		int fileno=0x04;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x0e || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}
		index=1;
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=output[3/*com settings*/];
		buffer[index++]=output[4/*access rights settings*/];
		buffer[index++]=output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}

		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		BYTE pTempData[36]={0};
		memset(pTempData,'X',36);
		int nDataLength=36;
		int offset=0;
		int records=1;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//records
		buffer[index++]=nDataLength;
		buffer[index++]=0;
		buffer[index++]=0;

		memcpy(&buffer[index],pTempData,nDataLength);
		index+=nDataLength;
		buffer[0]=index-1;
		clock.Start();
		RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_RECORDS, buffer, output);	
		clock.End();	
		szTemp=L"Write Record   ";	
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//18. Write Data .. file no=0x00, offset=0x0,Length=128
		index=1;
		int fileno=0x00;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[index++]=fileno;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS, buffer, output);
		clock.End();
		szTemp=L"GetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x08 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}
		index=1;
		ZeroMemory(buffer,1026);
		buffer[index++]=fileno;
		buffer[index++]=output[3/*com settings*/];
		buffer[index++]=output[4/*access rights settings*/];
		buffer[index++]=output[5/*access rights settings*/];
		buffer[0]=index-1;
		ZeroMemory(output,1026);
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS, buffer, output);
		clock.End();	
		szTemp=L"SetFileSettings   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		index=1;
		BYTE pTempData[128]={0};
		memset(pTempData,'X',128);
		int nDataLength=128;
		int offset=0;
		//offset
		buffer[index++]=offset;
		buffer[index++]=0;
		buffer[index++]=0;
		//Length...
		memcpy(&buffer[index],pTempData,nDataLength);
		index+=nDataLength;
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader,DESFIRE_WRITE_DATA, buffer, output);	
		clock.End();
		szTemp=L"Write data   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=1 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" Failed in reading");
			return ;
		}

	}
	{
		//19. Commit Transections
		index=1;
		ZeroMemory(buffer,1026);
		ZeroMemory(output,1026);
		buffer[0]=index-1;
		clock.Start(); 
		RDR_DESFire(theApp.m_hReader, DESFIRE_COMMIT_TRANSACTION, buffer, output);
		clock.End();
		szTemp=L"Commit Transection   ";
		szTemp.Append(clock.GetSecMs());
		theApp.m_Logpage->AddLog(szTemp);
		if(output[0]!=0x01 || output[1]!=0x00){
			theApp.m_Logpage->AddLog(L" fail in get file settings");
			return ;
		}
	}




	clockMain.End();
	szTemp.Format(L"Total Time Taken  %s",clockMain.GetSecMs());
	theApp.m_Logpage->AddLog(szTemp);
	theApp.m_Logpage->AddLog(L"Bench Mark Test2 End Successfully....");
}

void CSpeedTestPage::OnBnClickedCntread()
{

	/*	CString szTemp;
	char buffer[514];
	memset(buffer, 0x00, 514);

	char cCmd;
	char cData[10];

	cCmd = 0x00;
	cData[0]=0x01;
	cData[1]=0x01;
	sprintf(cData, "%02x", 0x01);
	RDR_DESFire(theApp.m_hReader,cCmd, cData, buffer);
	szTemp.Format(_T("%S"), buffer);
	AfxMessageBox(szTemp);
	return ;*/

	CString strVal;
	GetDlgItemText(IDC_CNTREAD,strVal);
	if(strVal.CompareNoCase(L"Start")==0){
		SetDlgItemText(IDC_CNTREAD,L"Stop");
		RDR_SendCommand(theApp.m_hReader, "continuous read", "");
		SetTimer(RECV_EVENT,100,NULL);
	}else{
		KillTimer(RECV_EVENT);
		RDR_SendCommand(theApp.m_hReader, ".", "");
		RDR_EmptyCommRcvBuffer(theApp.m_hCom);
		SetDlgItemText(IDC_CNTREAD,L"Start");
	}

}

void CSpeedTestPage::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	switch(nIDEvent){
				case RECV_EVENT:
					{
						KillTimer(RECV_EVENT);
						char pDataRec[2048]={0};
						unsigned int len[2]={0};
						CString strValue=L"";
						CString strValueanOther=L"";
						RDR_GetData2(theApp.m_hReader, pDataRec,len);
						if(*len){
							CHOperation1::Binary2Hex((BYTE*)pDataRec,strlen(pDataRec),strValue,true);					
							GetDlgItemText(IDC_LBL,strValueanOther);
							strValueanOther.Append(L"\r\n");
							strValueanOther.Append(strValue);
							SetDlgItemText(IDC_LBL,strValueanOther);

						}
						SetTimer(RECV_EVENT,100,NULL);
					}
					break;

	}
	CPropertyPage::OnTimer(nIDEvent);
}

/*void CSpeedTestPage::OnBnClickedRdrid()
{
char chRetBuff[MAX_PATH]={0};
if(!RDR_GetDeviceID(theApp.m_hReader,chRetBuff)){
TRACE0("Unable to Get Reader ID")	;
return;
}
CString strValueanOther,strValue;
GetDlgItemText(IDC_LBL,strValueanOther);
strValueanOther.Append(L"\r\n");
strValue=CString(chRetBuff);
strValueanOther.Append(strValue);
SetDlgItemText(IDC_LBL,strValueanOther);
BYTE bytStationID=RDR_GetStationID(theApp.m_hReader);
if(!bytStationID){
TRACE0("Unable to Get StationID")	;
return;
}

strValue.Format(L"%2X",bytStationID);
strValueanOther.Append(L"\r\n");
strValueanOther.Append(strValue);
SetDlgItemText(IDC_LBL,strValueanOther);


}*/

void CSpeedTestPage::OnBnClickedCntread2()
{

	// TODO: Implementation of ACS USb desconnect senerio
	//1. Getting Dll Version.
#define ACS USB_DISCONNECT
#ifdef ACS USB_DISCONNECT
#define MAX_LENGTH 1024
	char buffer[MAX_LENGTH]={0};
	RDR_GetDLLVersionStr(buffer);
	TRACE(buffer);
	presetSettings settings;
	settings.baudRate=460800;
	settings.protocol=1;
	//2.Opening comm at specified rate.
	HANDLE hComm=RDR_OpenComm("Com3",2,&settings);
	if(hComm==NULL){
		TRACE0("\nUnable to Open Comm")			;
		return;
	}
	//3. Reader Detection..
	ZeroMemory(buffer,MAX_LENGTH);
	RDR_DetectReader(hComm,buffer);
	//4. Opening reader			
	HANDLE hReader=RDR_OpenReader(hComm,buffer[0],0);
	if(hReader==NULL){
		("\nUnable to Open Reader")			;			
		return ;
	}
	//5. Setting reader Configuration.
	readerConfig readerCfg;
	readerCfg.baudRate=460800;
	readerCfg.protocol=1;
	readerCfg.stationID=1;
	RDR_SetReaderConfig(hReader,&readerCfg);
	//6.Empty recvBuffer, set com time out and then again empty recieve buffer
	RDR_EmptyCommRcvBuffer(hComm);
	RDR_SetCommTimeout(hComm,300);
	RDR_EmptyCommRcvBuffer(hComm);
	//7. Getting Reader type..
	ZeroMemory(buffer,MAX_LENGTH);
	RDR_GetReaderType(hReader,buffer);
	AddMessage(buffer);
	//8. Reset Reader request
	RDR_ResetReader(hReader);
	//9.Antena Power Off/On
	ZeroMemory(buffer,MAX_LENGTH);
	RDR_SendCommandGetData(hReader,"poff",buffer,buffer);
	ZeroMemory(buffer,MAX_LENGTH);
	RDR_SendCommandGetData(hReader,"pon",buffer,buffer);
	//
	buffer[0]=1;



	while(buffer[0]){
		ZeroMemory(buffer,MAX_LENGTH);			
		int index=0;
		buffer[index++]=0x02;
		buffer[index++]=0x05;
		buffer[index++]=0x05;
		RDR_SendCommandGetData(hReader,"y",buffer,buffer);
		AddMessage(buffer);
		ZeroMemory(buffer,MAX_LENGTH);
		index=0;			
		buffer[index++]=0x01;
		buffer[index++]=0x0D;
		RDR_SendCommand(hReader,"m",buffer);
		Sleep(1000);
		ZeroMemory(buffer,MAX_LENGTH);
		RDR_GetData(hReader,buffer);
		AddMessage(buffer);
		Sleep(100);
		TRACE0("\n");
	}
	RDR_EmptyCommRcvBuffer(hComm);
	RDR_CloseReader(hReader);
	RDR_CloseComm(hComm);
	//RDR_GetData(hReader,buffer);
	hComm=RDR_OpenComm("com3",2,&settings);
	if(hComm!=NULL)
		RDR_CloseComm(hComm);
	RDR_GetDLLVersionStr(buffer);
	AddMessage(buffer);
	TRACE(buffer);
#endif
	// When prtocol is Binary
	//Select High Speed
//#define HIGH_SPEED_TEST
#ifdef HIGH_SPEED_TEST

	char data[MAX_BUFFER]={0};
	char resp[MAX_BUFFER]={0};
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	int index=0;
	data[index++]=1;//length of Master application
	data[index++]=4;//length of Master application
	RDR_AbortContinuousRead(theApp.m_hCom);
	RDR_SendCommandGetData(theApp.m_hReader, "h", data, resp);
	AddMessage(resp);

	//Select Application.
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	index=0;
	data[index++]=3;//length of Master application
	RDR_DESFire(theApp.m_hReader,DESFIRE_SELECT_APPLICATION,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to select Master Application");
		return ;
	}
	AddMessage("Master Application selected.");
	////Getting Application IDS.
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	index=0;
	data[index++]=0;//length of Master application
	RDR_DESFire(theApp.m_hReader, DESFIRE_GET_APPLICATION_IDS,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to Get Application IDs");
		return ;
	}
	if(resp[0]<2){
		AddMessage("No Application found");
		return;
	}
	AddMessage("Application ID\'s are Here ");
	for (int i=0;i<(resp[0]-1)/3;i++)
	{
		char str[100]={0};
		sprintf(str,"%d. 0x%02X%02X%02X.",i+1,resp[2+i*3],resp[3+i*3],resp[4+i*3]);
		AddMessage(str);
	}
	//selecting first User application 
	ZeroMemory(data,MAX_BUFFER);
	index=0;
	data[index++]=3;//length of Master application
	memcpy(data+1,resp+2,3);
	ZeroMemory(resp,MAX_BUFFER);
	RDR_DESFire(theApp.m_hReader,DESFIRE_SELECT_APPLICATION,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to Select User Application");
		return ;
	}
	AddMessage("User Application selected");
	////Getting File IDs.
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_IDS,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to get File Ids");
		return ;
	}
	if(resp[0]<2){
		AddMessage("No File found");
		return;
	}
	AddMessage("Here is existing files");
	for (int i=0;i<(resp[0]-1);i++)
	{
		char str[100]={0};
		sprintf(str,"%d. 0x%02X.",i+1,resp[i+2]);
		AddMessage(str);
	}
	//Getting Settings.
	ZeroMemory(data,MAX_BUFFER);
	//putting file no in data.
	index=0;
	data[index++]=1;//length of Master application
	data[index++]=resp[2];
	ZeroMemory(resp,MAX_BUFFER);
	RDR_DESFire(theApp.m_hReader, DESFIRE_GET_FILE_SETTINGS,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to get File settings");
		return ;
	}
	char strMsg[100];
	char fileid=data[1];
	sprintf(strMsg,"Here are settings for File id= 0x%02X",fileid);
	AddMessage(strMsg);
	index=2;
	sprintf(strMsg,"file type =%02X ",resp[index]);
	AddMessage(strMsg);
	sprintf(strMsg,"Com Settings =%02X ",resp[index+1]);
	AddMessage(strMsg);
	sprintf(strMsg,"Key Settings =0x%02X%02X ",resp[index+3],resp[index+2]);

	AddMessage(strMsg);
	sprintf(strMsg,"File size =0x%02X%02X%02X",resp[index+6],resp[index+5],resp[index+4]);
	AddMessage(strMsg);
	////SetFile Settings
	ZeroMemory(data,MAX_BUFFER);
	index=0;
	data[index++]=4;
	data[index++]=fileid;
	memcpy(data+2,resp+2,3);
	ZeroMemory(resp,MAX_BUFFER);
	RDR_DESFire(theApp.m_hReader, DESFIRE_SET_FILE_SETTINGS,data,resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to set file setting");
		return ;
	}
	//Authentication.
	//
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	index=0;
	data[index++]=17;
	data[index++]=0x01;
	RDR_DESFire(theApp.m_hReader, DESFIRE_AUTHENICATE,data,resp);
	AddMessage(resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to Authenticate");
		return ;
	}
	sprintf(strMsg,"Authenticated with key %02X",data[1]);
	AddMessage(strMsg);
	////Reading data.
	ZeroMemory(data,MAX_BUFFER);
	ZeroMemory(resp,MAX_BUFFER);
	index=0;
	data[index++]=6;
	index+=3;
	data[index++]=0x0F;
	RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA,data,resp);
	if(!(resp[0]>0 && resp[1]==0)){
		AddMessage("Unable to read data");
		return ;
	}
	AddMessage("Recieved data");
	AddMessage(resp+2);
#endif

	return ;



}

void CSpeedTestPage::AddMessage(char msg[],int len)
{
	if(!len)
		len=strlen(msg);
	char *chrMessage= new char[len*2+2];
	if(RDR_GetBinProtocol(theApp.m_hReader))
		CHOperation1::Binary2ASCII((BYTE *)msg,len,chrMessage);
	m_MsgBoard.ReplaceSel(CString(chrMessage));
	delete[] chrMessage;
}
void CSpeedTestPage::AddMessage(CString msg,bool flag){
	if(flag)msg.Append(L"\r\n");
	m_MsgBoard.ReplaceSel(msg);

}
bool m_blIsLogging=true;
void CSpeedTestPage::OnBnClickedButton1()
{
	if(handle!=INVALID_HANDLE_VALUE){
		CloseHandle(handle);
		handle=INVALID_HANDLE_VALUE;
		return;
	}
	handle=CreateThread(NULL,0,ThreadProc,this,0,0);
	if(handle==INVALID_HANDLE_VALUE){
		AddMessage(L"unable to create thread.. try once more");
	}


}
DWORD WINAPI ThreadProc(LPVOID lpVoid){
	CSpeedTestPage *pTestPage=(CSpeedTestPage *)lpVoid;

	char resp[MAX_BUFFER]={0};
	char data[MAX_BUFFER]={0};
	int index=0;
	while(TRUE){
		if(RDR_GetBinProtocol(theApp.m_hReader)){//When protocol is binary
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			int index=0;
			data[index++]=1;//length of Master application
			data[index++]=4;//length of Master application
			RDR_AbortContinuousRead(theApp.m_hCom);
			RDR_SendCommandGetData(theApp.m_hReader ,"h", data, resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));

			//Select Application.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]=3;//length of Master application
			RDR_DESFire(theApp.m_hReader, DESFIRE_SELECT_APPLICATION,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
			if(!(resp[0]>0 && resp[1]==0)){
				pTestPage->AddMessage(L"Unable to select Master Application");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Master Application selected.");
			////Getting Application IDS.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]=0;//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_GET_APPLICATION_IDS,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
			if(!(resp[0]>0 && resp[1]==0)){
				pTestPage->AddMessage(L"Unable to Get Application IDs");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(resp[0]<2){
				pTestPage->AddMessage(L"No Application found");
				handle=INVALID_HANDLE_VALUE;
				return 0;
			}
			if(m_blIsLogging){pTestPage->AddMessage(L"Application ID\'s are Here ");
			for (int i=0;i<(resp[0]-1)/3;i++)
			{
				char str[100]={0};
				sprintf(str,"%d. 0x%02X%02X%02X.",i+1,resp[2+i*3],resp[3+i*3],resp[4+i*3]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(str));
			}
			}
			//selecting first User application 
			ZeroMemory(data,MAX_BUFFER);
			index=0;
			data[index++]=3;//length of Master application
			memcpy(data+1,resp+2,3);
			ZeroMemory(resp,MAX_BUFFER);
			RDR_DESFire(theApp.m_hReader,DESFIRE_SELECT_APPLICATION,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
			if(!(resp[0]>0 && resp[1]==0)){
				pTestPage->AddMessage(L"Unable to Select User Application");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"User Application selected");
			////Getting File IDs.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			RDR_DESFire(theApp.m_hReader,DESFIRE_GET_FILE_IDS,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
			if(!(resp[0]>0 && resp[1]==0)){
				pTestPage->AddMessage(L"Unable to get File Ids");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(resp[0]<2){
				pTestPage->AddMessage(L"No File found");
				handle=INVALID_HANDLE_VALUE;
				return 0;
			}
			if(m_blIsLogging){pTestPage->AddMessage(L"Here is existing files");
			for (int i=0;i<(resp[0]-1);i++)
			{
				char str[100]={0};
				sprintf(str,"%d. 0x%02X.",i+1,resp[i+2]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(str));
			}}
			//Getting Settings.
			char fileid=0x01;
			char strMsg[100];
			if(m_blIsLogging){	
				ZeroMemory(data,MAX_BUFFER);
				//putting file no in data.
				index=0;
				data[index++]=1;//length of Master application
				data[index++]=resp[2];
				ZeroMemory(resp,MAX_BUFFER);
				RDR_DESFire(theApp.m_hReader,DESFIRE_GET_FILE_SETTINGS,data,resp);
				if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
				if(!(resp[0]>0 && resp[1]==0)){
					pTestPage->AddMessage(L"Unable to get File settings");
					if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
				}


				fileid=data[1];
				sprintf(strMsg,"Here are settings for File id= 0x%02X",fileid);
				if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg));
				index=2;
				sprintf(strMsg,"file type =%02X ",resp[index]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg));
				sprintf(strMsg,"Com Settings =%02X ",resp[index+1]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg),false);
				sprintf(strMsg,"Key Settings =0x%02X%02X ",resp[index+3],resp[index+2]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg),false);
				sprintf(strMsg,"File size =0x%02X%02X%02X",resp[index+6],resp[index+5],resp[index+4]);
				if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg),false);
			}
			////SetFile Settings
			ZeroMemory(data,MAX_BUFFER);
			index=0;
			data[index++]=4;
			data[index++]=fileid;
			data[index++]=0x00;
			data[index++]=0xE0;
			data[index++]=0x01;

			memcpy(data+2,resp+2,3);
			ZeroMemory(resp,MAX_BUFFER);
			RDR_DESFire(theApp.m_hReader,DESFIRE_SET_FILE_SETTINGS,data,resp);
			if(!(resp[0]>0 && resp[1]==0)){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to set file setting");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			//Authentication.
			//
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]=17;
			data[index++]=0x01;
			RDR_DESFire(theApp.m_hReader,DESFIRE_AUTHENICATE,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);
			if(!(resp[0]>0 && resp[1]==0)){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to Authenticate");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			sprintf(strMsg,"Authenticated with key %02X",data[1]);
			if(m_blIsLogging)pTestPage->AddMessage(CString(strMsg));
			////Reading data.
			if(m_blIsLogging)pTestPage->AddMessage(L"Reading Data:");
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]=6;
			index+=3;
			data[index++]=0x0F;
			RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA,data,resp);
			if(!(resp[0]>0 && resp[1]==0)){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to read data");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Recieved data");
			if(m_blIsLogging)pTestPage->AddMessage(resp+2,resp[0]);



		}else{// When prtocol is not Binary i.e. ASCII
			//Select High Speed
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]='0';//length of Master application
			data[index++]='4';//length of Master application
			RDR_SendCommandGetData(theApp.m_hReader,"h", data, resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			RDR_AbortContinuousRead(theApp.m_hCom);
			//Select Application.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]='0';//length of Master application
			data[index++]='0';//length of Master application
			data[index++]='0';//length of Master application
			data[index++]='0';//length of Master application
			data[index++]='0';//length of Master application
			data[index++]='0';//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_SELECT_APPLICATION,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to select Master Application");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Master Application selected.");
			//Getting Application IDS.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			index=0;
			data[index++]=0;//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_GET_APPLICATION_IDS,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to Get Application IDs");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(strlen(resp)<=2){
				if(m_blIsLogging)pTestPage->AddMessage(L"No Application found");
				handle=INVALID_HANDLE_VALUE;
				return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Application ID\'s are Here ");
			for (int i=0;i<strlen(resp+2)/6;i++)
			{
				CString str;
				str.Format(L"%d. 0x%s.",i+1,CString(resp+(i*6)+2).Left(6));
				if(m_blIsLogging)pTestPage->AddMessage(str);
			}
			//selecting first User application 
			//Getting Application IDS.
			ZeroMemory(data,MAX_BUFFER);
			strncpy(data,resp+2,6);
			ZeroMemory(resp,MAX_BUFFER);
			//index=0;
			//data[index++]=0;//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_SELECT_APPLICATION,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to Select User Application");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"User Application selected");
			//Getting File IDs.
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			//index=0;
			//data[index++]=0;//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_GET_FILE_IDS,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to get File Ids");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(strlen(resp)<=2){
				if(m_blIsLogging)pTestPage->AddMessage(L"No File found");
				handle=INVALID_HANDLE_VALUE;
				return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Here is existing files");
			for (int i=0;i<strlen(resp+2)/2;i++)
			{
				CString str;
				str.Format(L"%d. 0x%s.",i+1,CString(resp+(i*2)+2).Left(2));
				if(m_blIsLogging)pTestPage->AddMessage(str);
			}
			//Getting Settings.
			ZeroMemory(data,MAX_BUFFER);
			//putting file no in data.
			memcpy(data,resp+2,2);
			ZeroMemory(resp,MAX_BUFFER);
			//index=0;
			//data[index++]=0;//length of Master application
			RDR_DESFire(theApp.m_hReader,DESFIRE_GET_FILE_SETTINGS,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to get File settings");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			CString strMsg;
			char fileid[2]={0};
			strcpy(fileid,data);
			strMsg.Format(L"Here are settings for File id= 0x%s",CString(data));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg);
			strMsg.Format(L"file type =%s ",CString(resp+2).Left(2));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg);
			strMsg.Format(L"Com Settings =%s ",CString(resp+4).Left(2));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg,false);
			strMsg.Format(L"Key Settings =0x%s%s ",CString(resp+8).Left(2),CString(resp+6).Left(2));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg,false);
			strMsg.Format(L"File size =0x%s%s%s ",CString(resp+14).Left(2),CString(resp+12).Left(2),CString(resp+10).Left(2));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg,false);
			//SetFile Settings
			ZeroMemory(data,MAX_BUFFER);
			strcpy(data,fileid);
			memcpy(data+2,resp+4,6);
			ZeroMemory(resp,MAX_BUFFER);
			RDR_DESFire(theApp.m_hReader,DESFIRE_SET_FILE_SETTINGS,data,resp);
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to set file setting");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			//Authentication.

			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			strcpy(data,"0100000000000000000000000000000000");
			RDR_DESFire(theApp.m_hReader,DESFIRE_AUTHENICATE,data,resp);
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp));
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to Authenticate");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			strMsg.Format(L"Authenticated with key %s",CString(data).Left(2));
			if(m_blIsLogging)pTestPage->AddMessage(strMsg);
			//Reading data.
			if(m_blIsLogging)pTestPage->AddMessage(L"Reading Data:");
			ZeroMemory(data,MAX_BUFFER);
			ZeroMemory(resp,MAX_BUFFER);
			strcpy(data,"0000000F0000");
			RDR_DESFire(theApp.m_hReader,DESFIRE_READ_DATA,data,resp);
			if(resp[0]!='0' && resp[1]!='0'){
				/*if(m_blIsLogging)*/pTestPage->AddMessage(L"Unable to read data");
				if(handle)	handle=INVALID_HANDLE_VALUE;	return 0;
			}
			if(m_blIsLogging)pTestPage->AddMessage(L"Recieved data");
			if(m_blIsLogging)pTestPage->AddMessage(CString(resp+2));
		}
		Sleep(10);
	}
	handle=INVALID_HANDLE_VALUE;
	return 0;
}