'Will used to Import MultiIso 
'You need to include the refernece of HidGlobal.MultiIso.CFReader assembly
'
Imports HidGlobal.MultiIso.CFReader

Public Class Form1
    ' creating a global reader object
    Dim reader As New HID_Reader

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'This Event use as to close reader and close an open com port.
        reader.RDR_CloseReader() 'closing reader object
        reader.RDR_CloseComm() 'closing virtual com port 
        txtLog.Text = vbCrLf & "Reader disconnected" & vbCrLf
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Used to selected preseneted card.
        reader.RDR_AbortContinuousReadExt() 'if reader is open in ASCII mode its continues read mode in ON by default.
        reader.RDR_EmptyCommRcvBuffer() ' clearing port form any garbage.
        Dim strRet As String = ""
        reader.RDR_SendCommandGetData("select", "", strRet) 'sending select command to get SNo of presented card.
        txtLog.Text = txtLog.Text & vbCrLf & strRet


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim psSettings As New HID_Reader.presetSettings
        Dim rcSettings As New HID_Reader.readerConfig
        Dim strVer As String
        strVer = ""

        reader.RDR_GetDLLVersionStr(strVer) 'trying to get Dll version
        txtLog.Text = "CFReader.dll Version=" & strVer & vbCrLf
        psSettings.baudRate = Convert.ToInt16(txtBaudrate.Text, 10)
        psSettings.protocol = Convert.ToInt16(RadioButton1.Checked)
        ' Trying to open connected reader on specified Baudrate and protocol settings.
        If reader.RDR_OpenSingle(txtComport.Text, Convert.ToByte(CheckBox1.Checked), 0, psSettings) Then
            reader.RDR_AbortContinuousReadExt() 'try to stop continuouse reading as it is on if connected mode in ASCII
            reader.RDR_EmptyCommRcvBuffer()
            txtLog.Text = txtLog.Text & "Connected.." & vbCrLf
            reader.RDR_GetReaderType(strVer) 'Getting reader information
            txtLog.Text = txtLog.Text & strVer & vbCrLf
            rcSettings = reader.RDR_GetReaderConfig 'Getting reader connection information.
            txtLog.Text = txtLog.Text & "BaudRate=" & rcSettings.baudRate.ToString() & "Protocol=" & rcSettings.protocol.ToString() & vbCrLf
            txtLog.Text = txtLog.Text & "Station ID=" & rcSettings.stationID.ToString() & vbCrLf
        Else
            txtLog.Text = txtLog.Text & "Unable to connect.."
        End If
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        Me.Close()
    End Sub
End Class
