Imports HidGlobal.MultiIso.Reader

Public Class Form1
    Dim reader As New HID_Reader
    Dim hCom As IntPtr = 0
    Dim hReader As IntPtr = 0
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        'Used to connect to reader attached.
        Dim psSettings As New HID_Reader.presetSettings
        Dim config As New HID_Reader.readerConfig
        Dim Temp As String = ""
        If hReader <> 0 And hCom <> 0 Then
            tb1.Text = tb1.Text & "Reader connected already" & vbCrLf
            Exit Sub
        End If
        psSettings.baudRate = Convert.ToInt16(BaudRateName.SelectedItem.ToString())
        psSettings.protocol = cmbProtocol.SelectedIndex
        If reader.RDR_OpenSingle(hCom, hReader, ComPortName.SelectedItem.ToString(), checkBox1.Checked, 0, psSettings) = 1 Then
            tb1.Text = tb1.Text & "Connected to Reader" & vbCrLf
            reader.RDR_GetReaderType(hReader, Temp)
            tb1.Text = tb1.Text & Temp & vbCrLf
            config = reader.RDR_GetReaderConfig(hReader)
            tb1.Text = tb1.Text & "at baudrate= " & config.baudRate & vbCrLf
            tb1.Text = tb1.Text & ", protocol= " & config.protocol & vbCrLf
            tb1.Text = tb1.Text & "and SationId= " & config.stationID & vbCrLf
        Else
            tb1.Text = tb1.Text & "Unable to connect.." & vbCrLf
        End If



    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'try to Get All serial com ports.
        Dim strValue As String = ""
        Dim len As Long = 1024
        Dim strvalues As String()
        reader.RDR_GetDLLVersionStr(strValue)
        reader.RDR_DetectSerialPort(strValue, len)
        strvalues = strValue.Split(" ")
        For Each strValue In strvalues
            ComPortName.Items.Add(strValue)
        Next strValue
        Debug.Print(strValue & len)
        ComPortName.SelectedIndex = 0
        BaudRateName.SelectedIndex = 0
        cmbProtocol.SelectedIndex = 0
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'Used to disconnect Reader.
        reader.RDR_CloseReader(hReader)
        reader.RDR_CloseComm(hCom)
        tb1.Text = tb1.Text & "Disconnected.. " & vbCrLf
        hReader = 0
        hCom = 0
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'Used to Select card and display a serial no of card
        Dim buff As String = ""
        If hReader = 0 And hCom = 0 Then
            tb1.Text = tb1.Text & "You need to connect reader" & vbCrLf
            Exit Sub
        End If
        reader.RDR_AbortContinuousReadExt(hReader)
        reader.RDR_EmptyCommRcvBuffer(hCom)

        reader.RDR_SendCommandGetData(hReader, "select", "", buff)
        tb1.Text = buff & vbCrLf & tb1.Text


    End Sub

   
    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        tb1.Text = ""
    End Sub
End Class
