// PropShtAperio.cpp : implementation file
//

#include "stdafx.h"
#include "ReaderDll_demo.h"
#include "PropSht.h"




// CPropSht

IMPLEMENT_DYNAMIC(CPropSht, CPropertySheet)

CPropSht::CPropSht(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{


	EnableAutomation();
}

CPropSht::CPropSht(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{

	EnableAutomation();
}

CPropSht::~CPropSht()
{
}

void CPropSht::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CPropertySheet::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CPropSht, CPropertySheet)
	ON_WM_PAINT()
ON_BN_CLICKED(IDHELP, &CPropSht::OnHelp)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CPropSht, CPropertySheet)
END_DISPATCH_MAP()

// Note: we add support for IID_IPropShtAperio to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {4FC8D092-9416-47E3-A736-E02FC6D0344E}
static const IID IID_IPropShtAperio =
{ 0x4FC8D092, 0x9416, 0x47E3, { 0xA7, 0x36, 0xE0, 0x2F, 0xC6, 0xD0, 0x34, 0x4E } };

BEGIN_INTERFACE_MAP(CPropSht, CPropertySheet)
	INTERFACE_PART(CPropSht, IID_IPropShtAperio, Dispatch)
END_INTERFACE_MAP()


// CPropSht message handlers

BOOL CPropSht::OnInitDialog()
	{
	CString szTemp;
	szTemp.LoadString(IDS_EXIT);
	BOOL bResult = CPropertySheet::OnInitDialog();
	( ( CButton* )GetDlgItem( IDOK ) )->ShowWindow( SW_HIDE );
	//( ( CButton* )GetDlgItem( ID_APPLY_NOW ) )->ShowWindow( SW_HIDE );
	( ( CButton* )GetDlgItem( IDCANCEL ) )->SetWindowText(szTemp);
	//( ( CButton* )GetDlgItem( IDCANCEL ) )->ShowWindow( SW_HIDE );
	//( ( CButton* )GetDlgItem( IDHELP ) )->ShowWindow( SW_HIDE );
	CRect rect;
	( ( CButton* )GetDlgItem( ID_APPLY_NOW ) )->GetWindowRect(&rect);
	ScreenToClient(rect);
	( ( CButton* )GetDlgItem( IDCANCEL ) )->SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),true);
	( ( CButton* )GetDlgItem( ID_APPLY_NOW ) )->ShowWindow( SW_HIDE );
	szTemp.LoadString(IDS_HELP);
	( ( CButton* )GetDlgItem( IDHELP ) )->SetWindowText(szTemp);
	

	//Put WindowText on the Pages..

	int i=GetPageCount();
	CPropertyPage *pp;
	while(i>0){
		pp= GetPage((i--)-1);
		SetActivePage(pp);
		}
	
	
	// TODO:  Add your specialized code here
	//GetDlgItem(IDOK)->GetWindowRect(rect);
	ScreenToClient(rect);

	return bResult;
	}
void CPropSht::OnHelp()
	{
	CAboutDlg dlg;
	dlg.DoModal();
	}
void CPropSht::OnPaint()
	{
	CPaintDC dc(this); // device context for painting

	CString szLogoText;
	CFont	fontLogo;

	szLogoText.LoadString(IDS_APP_NAME);

	if (szLogoText.IsEmpty())
	return;

	CRect rectTabCtrl;
	GetTabControl()->GetWindowRect(rectTabCtrl);
	ScreenToClient(rectTabCtrl);

	CRect rectOk;
	GetDlgItem(IDOK)->GetWindowRect(rectOk);
	ScreenToClient(rectOk);

	dc.SetBkMode(TRANSPARENT);

	CRect rectText;
	rectText.left = rectTabCtrl.left;
	rectText.top = rectOk.top;
	rectText.bottom = rectOk.bottom;
	rectText.right = rectOk.right;

	fontLogo.CreateFont(	rectText.bottom - rectText.top,	// nHeight
							0,								// nWidth
							0,								// nEscapement
							0,								// nOrientation
							FW_BOLD,						// nWeight
							TRUE,							// bItalic
							FALSE,							// bUnderline
							0,								// cStrikeOut
							ANSI_CHARSET,					// nCharSet
							OUT_DEFAULT_PRECIS,				// nOutPrecision
							CLIP_DEFAULT_PRECIS,			// nClipPrecision
							DEFAULT_QUALITY,				// nQuality
							DEFAULT_PITCH | FF_SWISS,		// nPitchAndFamily
							_T("Arial"));					// lpszFacename

	CFont * OldFont = dc.SelectObject(&fontLogo);

	// draw text in DC
	COLORREF OldColor = dc.SetTextColor(::GetSysColor(COLOR_3DHILIGHT));

	dc.DrawText(szLogoText, rectText + CPoint(1,1), 
	            DT_SINGLELINE | DT_LEFT | DT_VCENTER);
	dc.SetTextColor( ::GetSysColor( COLOR_3DSHADOW));
	dc.DrawText(szLogoText, rectText, DT_SINGLELINE | DT_LEFT | DT_VCENTER);

	// restore old text color
	dc.SetTextColor(OldColor);

	// restore old font
	dc.SelectObject(OldFont);

	// Do not call CPropertySheet::OnPaint() for painting messages
	}
void CPropSht::addPage(CPropertyPage* pPage)
	{
	}
