// ReaderDll_demo.h : main header file for the PROJECT_NAME application
//

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#include "resource.h"		// main symbols
#include "LogPage.h"
#include "ConnectionSettingsPage.h"
#include "ReaderDll.h"/*Used in Almost every where*/
#include "clock.h"//for clock orriented processing especially for logging with time.
// CReaderDll_demoApp:
// See ReaderDll_demo.cpp for the implementation of this class
//
enum DESFIRE_CMD{
	SAM_ON_OFF=0x00,
	AUTHENTICATE,
	CHANGE_KEY_SETTINGS,
	Get_Key_Settings,
	CHANGE_KEY,
	GET_KEY_VERSION,
	CREATE_APPLICATION,
	DELETE_APPLICATION,
	GET_APPLICATION_IDS,
	SELECT_APPLICATION,
	FORMAT_PICC,
	GET_VERSION,
	GET_FILE_IDS,
	GET_FILE_SETTINGS,
	CHANGE_FILE_SETTINGS,
	CREATE_STANDARD_DATA_FILE,
	CREATE_BACKUP_DATA_FILE,
	CREATE_VALUE_FILE,
	CREATE_LINEAR_RECORD_FILE,
	CREATE_CYCLIC_RECORD_FILE,
	DELETE_FILE,
	READ_DATA,
	READ_RECORDS,
	WRITE_DATA,
	WRITE_RECORDS,
	GET_VALUE,
	CREDIT,
	DEBIT,
	LIMITED_CREDIT,
	CLEAR_RECORD_FILE,
	COMMIT_TRANSACTION,
	ABORT_TRANSACTION,
	SET_FILE_SETTINGS,

	DISABLE_CRYPTO=0X30 ,
	CHANGE_KEY_ENTRY,
	GET_KEY_ENTRY,
	CHANGE_KUC_ENTRY,
	GET_KUC_ENTRY,
	CHANGE_KEY_PICC,
	GET_VERSION_SAM,
	AUTHENTICATE_HOST,
	SELECT_APPLICATION_SAM,
	DUMP_SESSION_KEY,
	LOAD_INIT_VECTOR,
	AUTHENTICATE_PICC_1,
	AUTHENTICATE_PICC_2,
	VERIFY_MAC,
	GENERATE_MAC,
	DECIPHER_DATA,
	ENCIPHER_DATA,
	SET_LOGICAL_CHANNEL

};
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
public:
	virtual BOOL OnInitDialog();
	};


class CReaderDll_demoApp : public CWinApp
{
public:
	CReaderDll_demoApp();
	CLogPage *m_Logpage;
	CConnectionSettingsPage *m_conStPage;
	HANDLE m_hCom;
	HANDLE m_hReader;
	
// Overrides
	public:
	virtual BOOL InitInstance();
	
// Implementation

	DECLARE_MESSAGE_MAP()
};

extern CReaderDll_demoApp theApp;
extern char* WidCharToChar(CString str);
//extern CLogPage m_Logpage;
//extern CSpeedTestPage m_speedTestpage;
//extern CConnectionSettingsPage m_conStPage;